<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import {
  LandingHero,
  ListHeader,
  CTADivider,
} from '../../components/solutions/index.vue';
import { getPageMetadata } from '~/common/meta';
import { NextStep, TopNavigation } from '~/components/common/index.vue';
import {
  FeaturesProductsCategoryCards,
  FeaturesCtaSection,
} from '~/components/features/index.vue';
import { processFeatureObjectHelper } from '~/lib/processFeaturesHelper';

export default Vue.extend({
  components: {
    LandingHero,
    ListHeader,
    NextStep,
    FeaturesProductsCategoryCards,
    FeaturesCtaSection,
    CTADivider,
    TopNavigation,
  },
  nuxtI18n: false,
  data() {
    return { proccesedFeatureBlocks: {} };
  },
  // eslint-disable-next-line
  async asyncData({ $content, params, error }: any) {
    try {
      const solutions = await $content(`solutions/index`).fetch();
      const { features } = await $content('synced/features').fetch();
      solutions.feature_blocks.forEach((block, index) => {
        solutions.feature_blocks[index].features = block.cards
          .map((card) => {
            const feature = features.find(
              (item) => item.title.toLowerCase() === card.title.toLowerCase(),
            );
            if (!feature) {
              return null;
            }
            if (card.display_title) {
              feature.title = card.display_title;
            }
            return processFeatureObjectHelper(feature, {
              card_animation: 'fade-up',
              card_animation_duration: 500,
            });
          })
          .filter((feature) => feature !== null);
      });
      return { solutions, features };
    } catch (e) {
      error({ statusCode: 404 });
      return {};
    }
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).solutions, this.$route.path);
  },
});
</script>

<template>
  <div>
    <SlpContainer>
      <LandingHero :data="solutions.hero" />
      <TopNavigation :data="solutions.navigation">
        <div
          v-for="block in solutions.feature_blocks"
          :id="block.id"
          :key="block.header.title"
        >
          <ListHeader :data="block.header" />
          <FeaturesProductsCategoryCards
            class="slp-mb-xs-64"
            :data="block.features"
            :current-category="block.header.title"
            :tab-title="block.header.title"
            :column-size="4"
            :has-stage-category="false"
            cards-data-ga-location="body"
            image-base-path="https://about.gitlab.com/images/feature_page/screenshots/"
          />
          <CTADivider
            :data="solutions.cta_divider"
            :feature-name="block.header.title"
          />
        </div>
      </TopNavigation>
      <FeaturesCtaSection />
    </SlpContainer>
    <SlpContainer variant="gradient">
      <NextStep>
        <template v-if="solutions['next-step']?.text" #ft-text>{{
          solutions['next-step'].text
        }}</template>
      </NextStep>
    </SlpContainer>
  </div>
</template>
